# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### ApiGatewayToLambdaCustomDomain <a name="ApiGatewayToLambdaCustomDomain" id="must-cdk.ApiGatewayToLambdaCustomDomain"></a>

#### Initializers <a name="Initializers" id="must-cdk.ApiGatewayToLambdaCustomDomain.Initializer"></a>

```typescript
import { ApiGatewayToLambdaCustomDomain } from 'must-cdk'

new ApiGatewayToLambdaCustomDomain(scope: Construct, id: string, props: ApiGatewayToLambdaProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | - represents the scope for all the resources. |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.Initializer.parameter.id">id</a></code> | <code>string</code> | - this is a a scope-unique id. |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.Initializer.parameter.props">props</a></code> | <code><a href="#must-cdk.ApiGatewayToLambdaProps">ApiGatewayToLambdaProps</a></code> | - user provided props for the construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.ApiGatewayToLambdaCustomDomain.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

represents the scope for all the resources.

---

##### `id`<sup>Required</sup> <a name="id" id="must-cdk.ApiGatewayToLambdaCustomDomain.Initializer.parameter.id"></a>

- *Type:* string

this is a a scope-unique id.

---

##### `props`<sup>Required</sup> <a name="props" id="must-cdk.ApiGatewayToLambdaCustomDomain.Initializer.parameter.props"></a>

- *Type:* <a href="#must-cdk.ApiGatewayToLambdaProps">ApiGatewayToLambdaProps</a>

user provided props for the construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.toString">toString</a></code> | Returns a string representation of this construct. |

---

##### `toString` <a name="toString" id="must-cdk.ApiGatewayToLambdaCustomDomain.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="must-cdk.ApiGatewayToLambdaCustomDomain.isConstruct"></a>

```typescript
import { ApiGatewayToLambdaCustomDomain } from 'must-cdk'

ApiGatewayToLambdaCustomDomain.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="must-cdk.ApiGatewayToLambdaCustomDomain.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.apiGateway">apiGateway</a></code> | <code>aws-cdk-lib.aws_apigateway.RestApi</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.apiGatewayLogGroup">apiGatewayLogGroup</a></code> | <code>aws-cdk-lib.aws_logs.LogGroup</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.Function</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.apiGatewayCloudWatchRole">apiGatewayCloudWatchRole</a></code> | <code>aws-cdk-lib.aws_iam.Role</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.aRecord">aRecord</a></code> | <code>aws-cdk-lib.aws_route53.ARecord</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.certificate">certificate</a></code> | <code>aws-cdk-lib.aws_certificatemanager.Certificate</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambdaCustomDomain.property.domain">domain</a></code> | <code>aws-cdk-lib.aws_apigateway.DomainName</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGateway`<sup>Required</sup> <a name="apiGateway" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.apiGateway"></a>

```typescript
public readonly apiGateway: RestApi;
```

- *Type:* aws-cdk-lib.aws_apigateway.RestApi

---

##### `apiGatewayLogGroup`<sup>Required</sup> <a name="apiGatewayLogGroup" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.apiGatewayLogGroup"></a>

```typescript
public readonly apiGatewayLogGroup: LogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroup

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: Function;
```

- *Type:* aws-cdk-lib.aws_lambda.Function

---

##### `apiGatewayCloudWatchRole`<sup>Optional</sup> <a name="apiGatewayCloudWatchRole" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.apiGatewayCloudWatchRole"></a>

```typescript
public readonly apiGatewayCloudWatchRole: Role;
```

- *Type:* aws-cdk-lib.aws_iam.Role

---

##### `aRecord`<sup>Optional</sup> <a name="aRecord" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.aRecord"></a>

```typescript
public readonly aRecord: ARecord;
```

- *Type:* aws-cdk-lib.aws_route53.ARecord

---

##### `certificate`<sup>Optional</sup> <a name="certificate" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.certificate"></a>

```typescript
public readonly certificate: Certificate;
```

- *Type:* aws-cdk-lib.aws_certificatemanager.Certificate

---

##### `domain`<sup>Optional</sup> <a name="domain" id="must-cdk.ApiGatewayToLambdaCustomDomain.property.domain"></a>

```typescript
public readonly domain: DomainName;
```

- *Type:* aws-cdk-lib.aws_apigateway.DomainName

---


### EcsCodeDeploy <a name="EcsCodeDeploy" id="must-cdk.EcsCodeDeploy"></a>

#### Initializers <a name="Initializers" id="must-cdk.EcsCodeDeploy.Initializer"></a>

```typescript
import { EcsCodeDeploy } from 'must-cdk'

new EcsCodeDeploy(scope: Construct, id: string, props: EcsCodeDeployProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.Initializer.parameter.props">props</a></code> | <code><a href="#must-cdk.EcsCodeDeployProps">EcsCodeDeployProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.EcsCodeDeploy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="must-cdk.EcsCodeDeploy.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="must-cdk.EcsCodeDeploy.Initializer.parameter.props"></a>

- *Type:* <a href="#must-cdk.EcsCodeDeployProps">EcsCodeDeployProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.toString">toString</a></code> | Returns a string representation of this construct. |

---

##### `toString` <a name="toString" id="must-cdk.EcsCodeDeploy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="must-cdk.EcsCodeDeploy.isConstruct"></a>

```typescript
import { EcsCodeDeploy } from 'must-cdk'

EcsCodeDeploy.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="must-cdk.EcsCodeDeploy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#must-cdk.EcsCodeDeploy.property.loadBalancer">loadBalancer</a></code> | <code>aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.service">service</a></code> | <code>aws-cdk-lib.aws_ecs.FargateService</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.taskDef">taskDef</a></code> | <code>aws-cdk-lib.aws_ecs.TaskDefinition</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="must-cdk.EcsCodeDeploy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `loadBalancer`<sup>Required</sup> <a name="loadBalancer" id="must-cdk.EcsCodeDeploy.property.loadBalancer"></a>

```typescript
public readonly loadBalancer: ApplicationLoadBalancer;
```

- *Type:* aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer

---

##### `service`<sup>Required</sup> <a name="service" id="must-cdk.EcsCodeDeploy.property.service"></a>

```typescript
public readonly service: FargateService;
```

- *Type:* aws-cdk-lib.aws_ecs.FargateService

---

##### `taskDef`<sup>Required</sup> <a name="taskDef" id="must-cdk.EcsCodeDeploy.property.taskDef"></a>

```typescript
public readonly taskDef: TaskDefinition;
```

- *Type:* aws-cdk-lib.aws_ecs.TaskDefinition

---


### WebsocketApiGatewayToLambdaCustomDomain <a name="WebsocketApiGatewayToLambdaCustomDomain" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain"></a>

#### Initializers <a name="Initializers" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.Initializer"></a>

```typescript
import { WebsocketApiGatewayToLambdaCustomDomain } from 'must-cdk'

new WebsocketApiGatewayToLambdaCustomDomain(scope: Construct, id: string, props: WebsocketApiGatewayToLambdaProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | - represents the scope for all the resources. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.Initializer.parameter.id">id</a></code> | <code>string</code> | - this is a a scope-unique id. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.Initializer.parameter.props">props</a></code> | <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps">WebsocketApiGatewayToLambdaProps</a></code> | - user provided props for the construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

represents the scope for all the resources.

---

##### `id`<sup>Required</sup> <a name="id" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.Initializer.parameter.id"></a>

- *Type:* string

this is a a scope-unique id.

---

##### `props`<sup>Required</sup> <a name="props" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.Initializer.parameter.props"></a>

- *Type:* <a href="#must-cdk.WebsocketApiGatewayToLambdaProps">WebsocketApiGatewayToLambdaProps</a>

user provided props for the construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.toString">toString</a></code> | Returns a string representation of this construct. |

---

##### `toString` <a name="toString" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.isConstruct"></a>

```typescript
import { WebsocketApiGatewayToLambdaCustomDomain } from 'must-cdk'

WebsocketApiGatewayToLambdaCustomDomain.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.apiGateway">apiGateway</a></code> | <code>aws-cdk-lib.aws_apigateway.RestApi</code> | *No description.* |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.apiGatewayLogGroup">apiGatewayLogGroup</a></code> | <code>aws-cdk-lib.aws_logs.LogGroup</code> | *No description.* |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.Function</code> | *No description.* |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.apiGatewayCloudWatchRole">apiGatewayCloudWatchRole</a></code> | <code>aws-cdk-lib.aws_iam.Role</code> | *No description.* |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.aRecord">aRecord</a></code> | <code>aws-cdk-lib.aws_route53.ARecord</code> | *No description.* |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.certificate">certificate</a></code> | <code>aws-cdk-lib.aws_certificatemanager.Certificate</code> | *No description.* |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.domain">domain</a></code> | <code>aws-cdk-lib.aws_apigateway.DomainName</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGateway`<sup>Required</sup> <a name="apiGateway" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.apiGateway"></a>

```typescript
public readonly apiGateway: RestApi;
```

- *Type:* aws-cdk-lib.aws_apigateway.RestApi

---

##### `apiGatewayLogGroup`<sup>Required</sup> <a name="apiGatewayLogGroup" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.apiGatewayLogGroup"></a>

```typescript
public readonly apiGatewayLogGroup: LogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroup

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: Function;
```

- *Type:* aws-cdk-lib.aws_lambda.Function

---

##### `apiGatewayCloudWatchRole`<sup>Optional</sup> <a name="apiGatewayCloudWatchRole" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.apiGatewayCloudWatchRole"></a>

```typescript
public readonly apiGatewayCloudWatchRole: Role;
```

- *Type:* aws-cdk-lib.aws_iam.Role

---

##### `aRecord`<sup>Optional</sup> <a name="aRecord" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.aRecord"></a>

```typescript
public readonly aRecord: ARecord;
```

- *Type:* aws-cdk-lib.aws_route53.ARecord

---

##### `certificate`<sup>Optional</sup> <a name="certificate" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.certificate"></a>

```typescript
public readonly certificate: Certificate;
```

- *Type:* aws-cdk-lib.aws_certificatemanager.Certificate

---

##### `domain`<sup>Optional</sup> <a name="domain" id="must-cdk.WebsocketApiGatewayToLambdaCustomDomain.property.domain"></a>

```typescript
public readonly domain: DomainName;
```

- *Type:* aws-cdk-lib.aws_apigateway.DomainName

---


## Structs <a name="Structs" id="Structs"></a>

### ApiGatewayToLambdaProps <a name="ApiGatewayToLambdaProps" id="must-cdk.ApiGatewayToLambdaProps"></a>

#### Initializer <a name="Initializer" id="must-cdk.ApiGatewayToLambdaProps.Initializer"></a>

```typescript
import { ApiGatewayToLambdaProps } from 'must-cdk'

const apiGatewayToLambdaProps: ApiGatewayToLambdaProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.apiGatewayProps">apiGatewayProps</a></code> | <code>any</code> | Optional user-provided props to override the default props for the API. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.createUsagePlan">createUsagePlan</a></code> | <code>boolean</code> | Whether to create a Usage Plan attached to the API. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.customDomainName">customDomainName</a></code> | <code>string</code> | Optional custom domain name for API Gateway, an ACM cert will also created. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.existingLambdaObj">existingLambdaObj</a></code> | <code>aws-cdk-lib.aws_lambda.Function</code> | Existing instance of Lambda Function object, providing both this and `lambdaFunctionProps` will cause an error. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.hostedZone">hostedZone</a></code> | <code>aws-cdk-lib.aws_route53.IHostedZone</code> | Optional Route53 hosted zone to create alias record for the custom domain. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.lambdaFunctionProps">lambdaFunctionProps</a></code> | <code>aws-cdk-lib.aws_lambda.FunctionProps</code> | User provided props to override the default props for the Lambda function. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.logGroupProps">logGroupProps</a></code> | <code>aws-cdk-lib.aws_logs.LogGroupProps</code> | *No description.* |

---

##### `apiGatewayProps`<sup>Optional</sup> <a name="apiGatewayProps" id="must-cdk.ApiGatewayToLambdaProps.property.apiGatewayProps"></a>

```typescript
public readonly apiGatewayProps: any;
```

- *Type:* any

Optional user-provided props to override the default props for the API.

---

##### `createUsagePlan`<sup>Optional</sup> <a name="createUsagePlan" id="must-cdk.ApiGatewayToLambdaProps.property.createUsagePlan"></a>

```typescript
public readonly createUsagePlan: boolean;
```

- *Type:* boolean

Whether to create a Usage Plan attached to the API.

Must be true if
apiGatewayProps.defaultMethodOptions.apiKeyRequired is true

---

##### `customDomainName`<sup>Optional</sup> <a name="customDomainName" id="must-cdk.ApiGatewayToLambdaProps.property.customDomainName"></a>

```typescript
public readonly customDomainName: string;
```

- *Type:* string
- *Default:* no custom domain

Optional custom domain name for API Gateway, an ACM cert will also created.

---

##### `existingLambdaObj`<sup>Optional</sup> <a name="existingLambdaObj" id="must-cdk.ApiGatewayToLambdaProps.property.existingLambdaObj"></a>

```typescript
public readonly existingLambdaObj: Function;
```

- *Type:* aws-cdk-lib.aws_lambda.Function
- *Default:* None

Existing instance of Lambda Function object, providing both this and `lambdaFunctionProps` will cause an error.

---

##### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.ApiGatewayToLambdaProps.property.hostedZone"></a>

```typescript
public readonly hostedZone: IHostedZone;
```

- *Type:* aws-cdk-lib.aws_route53.IHostedZone
- *Default:* no Route53 alias record created

Optional Route53 hosted zone to create alias record for the custom domain.

---

##### `lambdaFunctionProps`<sup>Optional</sup> <a name="lambdaFunctionProps" id="must-cdk.ApiGatewayToLambdaProps.property.lambdaFunctionProps"></a>

```typescript
public readonly lambdaFunctionProps: FunctionProps;
```

- *Type:* aws-cdk-lib.aws_lambda.FunctionProps

User provided props to override the default props for the Lambda function.

---

##### `logGroupProps`<sup>Optional</sup> <a name="logGroupProps" id="must-cdk.ApiGatewayToLambdaProps.property.logGroupProps"></a>

```typescript
public readonly logGroupProps: LogGroupProps;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroupProps

---

### AutoScalingProps <a name="AutoScalingProps" id="must-cdk.AutoScalingProps"></a>

Configuration for ECS service auto-scaling.

#### Initializer <a name="Initializer" id="must-cdk.AutoScalingProps.Initializer"></a>

```typescript
import { AutoScalingProps } from 'must-cdk'

const autoScalingProps: AutoScalingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.AutoScalingProps.property.maxCapacity">maxCapacity</a></code> | <code>number</code> | Maximum number of tasks to run. |
| <code><a href="#must-cdk.AutoScalingProps.property.minCapacity">minCapacity</a></code> | <code>number</code> | Minimum number of tasks to run. |
| <code><a href="#must-cdk.AutoScalingProps.property.cpuScale">cpuScale</a></code> | <code>aws-cdk-lib.aws_ecs.CpuUtilizationScalingProps</code> | Scale task based on CPU utilization. |
| <code><a href="#must-cdk.AutoScalingProps.property.memoryScale">memoryScale</a></code> | <code>aws-cdk-lib.aws_ecs.MemoryUtilizationScalingProps</code> | Scale task based on memory utilization. |

---

##### `maxCapacity`<sup>Required</sup> <a name="maxCapacity" id="must-cdk.AutoScalingProps.property.maxCapacity"></a>

```typescript
public readonly maxCapacity: number;
```

- *Type:* number

Maximum number of tasks to run.

---

##### `minCapacity`<sup>Required</sup> <a name="minCapacity" id="must-cdk.AutoScalingProps.property.minCapacity"></a>

```typescript
public readonly minCapacity: number;
```

- *Type:* number

Minimum number of tasks to run.

---

##### `cpuScale`<sup>Optional</sup> <a name="cpuScale" id="must-cdk.AutoScalingProps.property.cpuScale"></a>

```typescript
public readonly cpuScale: CpuUtilizationScalingProps;
```

- *Type:* aws-cdk-lib.aws_ecs.CpuUtilizationScalingProps

Scale task based on CPU utilization.

---

##### `memoryScale`<sup>Optional</sup> <a name="memoryScale" id="must-cdk.AutoScalingProps.property.memoryScale"></a>

```typescript
public readonly memoryScale: MemoryUtilizationScalingProps;
```

- *Type:* aws-cdk-lib.aws_ecs.MemoryUtilizationScalingProps

Scale task based on memory utilization.

---

### ContainerProps <a name="ContainerProps" id="must-cdk.ContainerProps"></a>

Configuration for the ECS Fargate task definition and container.

#### Initializer <a name="Initializer" id="must-cdk.ContainerProps.Initializer"></a>

```typescript
import { ContainerProps } from 'must-cdk'

const containerProps: ContainerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ContainerProps.property.albListenerContainerPort">albListenerContainerPort</a></code> | <code>number</code> | The port number the container listens on. |
| <code><a href="#must-cdk.ContainerProps.property.containerPort">containerPort</a></code> | <code>number</code> | The port number the container listens on. |
| <code><a href="#must-cdk.ContainerProps.property.image">image</a></code> | <code>aws-cdk-lib.aws_ecs.ContainerImage</code> | Container image to deploy. |
| <code><a href="#must-cdk.ContainerProps.property.healthCheck">healthCheck</a></code> | <code>aws-cdk-lib.aws_ecs.HealthCheck</code> | Optional container health check configuration. |
| <code><a href="#must-cdk.ContainerProps.property.memoryLimit">memoryLimit</a></code> | <code>number</code> | Hard memory limit in MiB for the task (default: 2048). |
| <code><a href="#must-cdk.ContainerProps.property.memoryReservation">memoryReservation</a></code> | <code>number</code> | Soft memory reservation in MiB for the container (default: 1024). |

---

##### `albListenerContainerPort`<sup>Required</sup> <a name="albListenerContainerPort" id="must-cdk.ContainerProps.property.albListenerContainerPort"></a>

```typescript
public readonly albListenerContainerPort: number;
```

- *Type:* number

The port number the container listens on.

---

##### `containerPort`<sup>Required</sup> <a name="containerPort" id="must-cdk.ContainerProps.property.containerPort"></a>

```typescript
public readonly containerPort: number;
```

- *Type:* number

The port number the container listens on.

---

##### `image`<sup>Required</sup> <a name="image" id="must-cdk.ContainerProps.property.image"></a>

```typescript
public readonly image: ContainerImage;
```

- *Type:* aws-cdk-lib.aws_ecs.ContainerImage

Container image to deploy.

---

##### `healthCheck`<sup>Optional</sup> <a name="healthCheck" id="must-cdk.ContainerProps.property.healthCheck"></a>

```typescript
public readonly healthCheck: HealthCheck;
```

- *Type:* aws-cdk-lib.aws_ecs.HealthCheck

Optional container health check configuration.

---

##### `memoryLimit`<sup>Optional</sup> <a name="memoryLimit" id="must-cdk.ContainerProps.property.memoryLimit"></a>

```typescript
public readonly memoryLimit: number;
```

- *Type:* number

Hard memory limit in MiB for the task (default: 2048).

---

##### `memoryReservation`<sup>Optional</sup> <a name="memoryReservation" id="must-cdk.ContainerProps.property.memoryReservation"></a>

```typescript
public readonly memoryReservation: number;
```

- *Type:* number

Soft memory reservation in MiB for the container (default: 1024).

---

### EcsCodeDeployProps <a name="EcsCodeDeployProps" id="must-cdk.EcsCodeDeployProps"></a>

Properties for the EcsCodeDeploy construct.

#### Initializer <a name="Initializer" id="must-cdk.EcsCodeDeployProps.Initializer"></a>

```typescript
import { EcsCodeDeployProps } from 'must-cdk'

const ecsCodeDeployProps: EcsCodeDeployProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_ecs.ICluster</code> | ECS Cluster where the service will run. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.containers">containers</a></code> | <code><a href="#must-cdk.ContainerProps">ContainerProps</a>[]</code> | Configuration related to the task definition and container. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.environment">environment</a></code> | <code>string</code> | Environment name (e.g., dev, prod) for tagging and naming. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.serviceName">serviceName</a></code> | <code>string</code> | Base name used for resources like log groups, roles, services, etc. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.taskExecRole">taskExecRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | Task execution role for the ECS task. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.taskRole">taskRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | Task role for the ECS task. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | VPC in which to deploy ECS and ALB resources. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.autoScaling">autoScaling</a></code> | <code><a href="#must-cdk.AutoScalingProps">AutoScalingProps</a></code> | Optional auto-scaling configuration. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.certificates">certificates</a></code> | <code>aws-cdk-lib.aws_certificatemanager.ICertificate[]</code> | Optional ACM certificates for HTTPS termination. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.enablePublicLoadBalancer">enablePublicLoadBalancer</a></code> | <code>boolean</code> | Whether the load balancer should be internet-facing (default: false). |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.memoryLimit">memoryLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.taskCPU">taskCPU</a></code> | <code>number</code> | CPU units for the task (default: 1024). |

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="must-cdk.EcsCodeDeployProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_ecs.ICluster

ECS Cluster where the service will run.

---

##### `containers`<sup>Required</sup> <a name="containers" id="must-cdk.EcsCodeDeployProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#must-cdk.ContainerProps">ContainerProps</a>[]

Configuration related to the task definition and container.

---

##### `environment`<sup>Required</sup> <a name="environment" id="must-cdk.EcsCodeDeployProps.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Environment name (e.g., dev, prod) for tagging and naming.

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="must-cdk.EcsCodeDeployProps.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Base name used for resources like log groups, roles, services, etc.

---

##### `taskExecRole`<sup>Required</sup> <a name="taskExecRole" id="must-cdk.EcsCodeDeployProps.property.taskExecRole"></a>

```typescript
public readonly taskExecRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

Task execution role for the ECS task.

---

##### `taskRole`<sup>Required</sup> <a name="taskRole" id="must-cdk.EcsCodeDeployProps.property.taskRole"></a>

```typescript
public readonly taskRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

Task role for the ECS task.

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="must-cdk.EcsCodeDeployProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

VPC in which to deploy ECS and ALB resources.

---

##### `autoScaling`<sup>Optional</sup> <a name="autoScaling" id="must-cdk.EcsCodeDeployProps.property.autoScaling"></a>

```typescript
public readonly autoScaling: AutoScalingProps;
```

- *Type:* <a href="#must-cdk.AutoScalingProps">AutoScalingProps</a>

Optional auto-scaling configuration.

---

##### `certificates`<sup>Optional</sup> <a name="certificates" id="must-cdk.EcsCodeDeployProps.property.certificates"></a>

```typescript
public readonly certificates: ICertificate[];
```

- *Type:* aws-cdk-lib.aws_certificatemanager.ICertificate[]

Optional ACM certificates for HTTPS termination.

---

##### `enablePublicLoadBalancer`<sup>Optional</sup> <a name="enablePublicLoadBalancer" id="must-cdk.EcsCodeDeployProps.property.enablePublicLoadBalancer"></a>

```typescript
public readonly enablePublicLoadBalancer: boolean;
```

- *Type:* boolean

Whether the load balancer should be internet-facing (default: false).

---

##### `memoryLimit`<sup>Optional</sup> <a name="memoryLimit" id="must-cdk.EcsCodeDeployProps.property.memoryLimit"></a>

```typescript
public readonly memoryLimit: number;
```

- *Type:* number

---

##### `taskCPU`<sup>Optional</sup> <a name="taskCPU" id="must-cdk.EcsCodeDeployProps.property.taskCPU"></a>

```typescript
public readonly taskCPU: number;
```

- *Type:* number

CPU units for the task (default: 1024).

---

### WebsocketApiGatewayToLambdaProps <a name="WebsocketApiGatewayToLambdaProps" id="must-cdk.WebsocketApiGatewayToLambdaProps"></a>

#### Initializer <a name="Initializer" id="must-cdk.WebsocketApiGatewayToLambdaProps.Initializer"></a>

```typescript
import { WebsocketApiGatewayToLambdaProps } from 'must-cdk'

const websocketApiGatewayToLambdaProps: WebsocketApiGatewayToLambdaProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps.property.apiGatewayProps">apiGatewayProps</a></code> | <code>any</code> | Optional user-provided props to override the default props for the API. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps.property.createUsagePlan">createUsagePlan</a></code> | <code>boolean</code> | Whether to create a Usage Plan attached to the API. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps.property.customDomainName">customDomainName</a></code> | <code>string</code> | Optional custom domain name for API Gateway, an ACM cert will also created. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps.property.existingLambdaObj">existingLambdaObj</a></code> | <code>aws-cdk-lib.aws_lambda.Function</code> | Existing instance of Lambda Function object, providing both this and `lambdaFunctionProps` will cause an error. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps.property.hostedZone">hostedZone</a></code> | <code>aws-cdk-lib.aws_route53.IHostedZone</code> | Optional Route53 hosted zone to create alias record for the custom domain. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps.property.lambdaFunctionProps">lambdaFunctionProps</a></code> | <code>aws-cdk-lib.aws_lambda.FunctionProps</code> | User provided props to override the default props for the Lambda function. |
| <code><a href="#must-cdk.WebsocketApiGatewayToLambdaProps.property.logGroupProps">logGroupProps</a></code> | <code>aws-cdk-lib.aws_logs.LogGroupProps</code> | *No description.* |

---

##### `apiGatewayProps`<sup>Optional</sup> <a name="apiGatewayProps" id="must-cdk.WebsocketApiGatewayToLambdaProps.property.apiGatewayProps"></a>

```typescript
public readonly apiGatewayProps: any;
```

- *Type:* any

Optional user-provided props to override the default props for the API.

---

##### `createUsagePlan`<sup>Optional</sup> <a name="createUsagePlan" id="must-cdk.WebsocketApiGatewayToLambdaProps.property.createUsagePlan"></a>

```typescript
public readonly createUsagePlan: boolean;
```

- *Type:* boolean

Whether to create a Usage Plan attached to the API.

Must be true if
apiGatewayProps.defaultMethodOptions.apiKeyRequired is true

---

##### `customDomainName`<sup>Optional</sup> <a name="customDomainName" id="must-cdk.WebsocketApiGatewayToLambdaProps.property.customDomainName"></a>

```typescript
public readonly customDomainName: string;
```

- *Type:* string
- *Default:* no custom domain

Optional custom domain name for API Gateway, an ACM cert will also created.

---

##### `existingLambdaObj`<sup>Optional</sup> <a name="existingLambdaObj" id="must-cdk.WebsocketApiGatewayToLambdaProps.property.existingLambdaObj"></a>

```typescript
public readonly existingLambdaObj: Function;
```

- *Type:* aws-cdk-lib.aws_lambda.Function
- *Default:* None

Existing instance of Lambda Function object, providing both this and `lambdaFunctionProps` will cause an error.

---

##### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.WebsocketApiGatewayToLambdaProps.property.hostedZone"></a>

```typescript
public readonly hostedZone: IHostedZone;
```

- *Type:* aws-cdk-lib.aws_route53.IHostedZone
- *Default:* no Route53 alias record created

Optional Route53 hosted zone to create alias record for the custom domain.

---

##### `lambdaFunctionProps`<sup>Optional</sup> <a name="lambdaFunctionProps" id="must-cdk.WebsocketApiGatewayToLambdaProps.property.lambdaFunctionProps"></a>

```typescript
public readonly lambdaFunctionProps: FunctionProps;
```

- *Type:* aws-cdk-lib.aws_lambda.FunctionProps

User provided props to override the default props for the Lambda function.

---

##### `logGroupProps`<sup>Optional</sup> <a name="logGroupProps" id="must-cdk.WebsocketApiGatewayToLambdaProps.property.logGroupProps"></a>

```typescript
public readonly logGroupProps: LogGroupProps;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroupProps

---



